/*
 * IBM Confidential
 * Rational Team Concert
 * (C)Copyright IBM Corporation 2011, 2012. 
 * 
 * The source code for this program is not published or otherwise divested
 * of its trade secrets, irrespective of what has been deposited with the
 * U.S. Copyright Office.
 *
 * RtcScc.h: Declares the additional APIs defined by Rational Team Concert MS-SCCI Client.
 */

#if !defined RTC_SCC_H
#define      RTC_SCC_H (1)

#include "stdafx.h"

#include "Windows.h"
#include "atlbase.h"

#pragma once

#include "scc.h"

/****************************************************************************
    Linkage for external functions will be C naming mode.
****************************************************************************/
#if defined( __cplusplus )
extern "C" {
#endif

#define RTC_SCC_USER_PREF_LEN               (128)
#define RTC_SCC_USER_PREF_SIZE              (RTC_SCC_USER_PREF_LEN+1)

typedef enum
{
    CHECKOUT_LOCKFILE = 0,
    UNDOCHECKOUT_UNLOCKFILE,
    CHECKIN_DELIVERCHANGES,
    CHECKIN_UNLOCKFILEAFTERDELIVERING,
    PENDINGCHANGES_AUTOOPENATSTARTUP,
    ASSOCIATE_WORKITEM_CHECKIN,
    GET_OVERWRITELOCAL,
    MISCELLANEOUS_ALWAYSFETCHPROPERTIESFROMSERVER,
    MISCELLANEOUS_GLOBALTRACELEVEL,
    REMOVE_KEEPLOCALFILE,
    REMOVE_DELIVERFILES,
    RENAME_KEEPLOCALFILE,
    RENAME_DELIVERFILES,
    UILANGUAGE_USESYSTEMLOCALE,
    COMPARETOOL_USEEXTERNALTOOL,
    COMPARETOOL_TOOLTOUSE,
    COMPARETOOL_TOOL_TWOWAYEXECUTABLEPATH,
    COMPARETOOL_TOOL_TWOWAYLOCALCOMPAREARGSFORMAT,
    COMPARETOOL_TOOL_TWOWAYREMOTECOMPAREARGSFORMAT,
    COMPARETOOL_TOOL_SUPPORTSTHREEWAYCOMPARE,
    COMPARETOOL_TOOL_THREEWAYEXECUTABLEPATH,
    COMPARETOOL_TOOL_THREEWAYARGSFORMAT
} ERtcSccUserPreference;

/*******************************************************************************
 * RtcSccGetUserPreference:
 * API to get the Rational Team Concert MS-SCCI Client's user preference
 *******************************************************************************/
SCCEXTERNC SCCRTN EXTFUN __cdecl RtcSccGetUserPreference(_Inout_                                       LPVOID                pContext,
                                                         _In_                                          ERtcSccUserPreference userPrefId,
                                                         _Inout_z_ _Inout_cap_(RTC_SCC_USER_PREF_SIZE) LPSTR                 lpPrefVal);

/*******************************************************************************
 * RtcSccSetUserPreference:
 * API to set the Rational Team Concert MS-SCCI Client's user preference
 *******************************************************************************/
SCCEXTERNC SCCRTN EXTFUN __cdecl RtcSccSetUserPreference(_Inout_                                       LPVOID                pContext,
                                                         _In_                                          ERtcSccUserPreference userPrefId,
                                                         _Inout_z_ _Inout_cap_(RTC_SCC_USER_PREF_SIZE) LPSTR                 lpPrefVal);

/*******************************************************************************
 * RtcSccOpenPendingChangesView:
 * Opens the Rational Team Concert Pending Changes view, if not already open;
 * Otherwise, it has no effect.
 *******************************************************************************/
SCCEXTERNC SCCRTN EXTFUN __cdecl RtcSccOpenPendingChangesView(_Inout_ LPVOID pContext);

/*******************************************************************************
 * RtcSccClosePendingChangesView:
 * Closes the Rational Team Concert Pending Changes view, if already open;
 * Otherwise, it has not effect
 *******************************************************************************/
SCCEXTERNC SCCRTN EXTFUN __cdecl RtcSccClosePendingChangesView(_Inout_ LPVOID pContext);

#if defined( __cplusplus )
}
#endif

#endif /* RTC_SCC_H */
